C
C--------------------------------------------------------------------
C     MAKES DATA FOR 2D MAP OF THE (100)-, (010)- OR (001)-PLANE
C     result in 2-dim array D()
C--------------------------------------------------------------------
C
      SUBROUTINE MAP100(mapt,mpix,NPIX,nmx,nmy,vx,vy,theta,rad,
     $  CELL,DELC,D,lx,ly,dmin,dmax,axisX,axisY,
     $  imapso,imapsx,imapsy,imapuc,imaptr,
     $  imapsp,imapse,imapsf,imapst)
C
      implicit none
      integer mapt,mpix,NPIX(3),nmx,nmy,lx,ly
C     *** DELC(0..npix(1)-1, 0.. , 0..) contains the whole cell 3-dim density
      real*8 DELC(0:mpix,0:mpix,0:mpix),dd
C     *** D(1..lx,1..ly) gets the 2-dim map from this subroutine
      real*8 D(2*mpix+1,2*mpix+1),dmin,dmax,vx,vy,theta,rad,CELL(6)
      CHARACTER axisX*5,axisY*5
      integer IAXIS(6),imapso,imapsx,imapsy,imapuc,imaptr,
     $        imapsp,imapse,imapsf,imapst
      integer nfn,nin,iax,iay,nh,nv,np,i,j,mapk
      logical CR,error
      real*8 wert
      DATA IAXIS/2,3,1,3,1,2/
C
C 2000 FORMAT(BN,I3)
 3010 FORMAT(/' Select the type of plane. 0: single, 1: projection ' 
     $ ,'[default=',i3,'] ',$)
 3030 FORMAT(' Input section plane number ( 0 - ',I3,' )',13x 
     $ ,'[default=',i3,'] ',$)
 3040 FORMAT(' Input plane number for sum: from ( 0 - ',I3,' )     '
     $ ,'[default=',i3,'] ',$)
 3050 FORMAT(' Input plane number for sum:   to ( 0 - ',I3,' )     '
     $ ,'[default=',i3,'] ',$)
C
C** SETS & CALCULATES GRAPHIC PARAMETERS ***
C
      mapk=mapt-1

C     *** section or projection ?
10    WRITE(*,3010) imapsp
      CALL abfrage(wert,i,CR,error)
      if (error) goto 10
      if (.not.CR) then
        if (i.gt.1 .or. i.lt.0) then
          print *,'wrong input: has to be 0 or 1'
          goto 10
        else 
          imapsp=i
        endif
      endif

      IF (imapsp.EQ.0) THEN
C       ***  single plane ***
12      WRITE(*,3030) NPIX(mapk)-1, imapse
        CALL abfrage(wert,i,CR,error)
        if (error) goto 12
        if (.not.CR) then
          if (i.ge.NPIX(mapk) .or. i.lt.0) then
            print *,'wrong input'
            goto 12
          else 
            imapse=i
          endif
        endif
        nin=imapse
        nfn=nin
      ELSE
C       ***  projection from section ***
13      WRITE(*,3040) NPIX(mapk)-1,imapsf
        CALL abfrage(wert,i,CR,error)
        if (error) goto 13
        if (.not.CR) then
          if (i.ge.NPIX(mapk) .or. i.lt.0) then
            print *,'wrong input'
            goto 13
          else 
            imapsf=i
          endif
        endif
        nin=imapsf
C       ***  projection to section ***
14      WRITE(*,3050) NPIX(mapk)-1,imapst
        CALL abfrage(wert,i,CR,error)
        if (error) goto 14
        if (.not.CR) then
          if (i.ge.NPIX(mapk) .or. i.lt.0) then
            print *,'wrong input'
            goto 14
          else 
            imapst=i
          endif
        endif
        nfn=imapst
      END IF
C
      iax=IAXIS(mapk)
      iay=IAXIS(mapk+3)
      nmx=NPIX(iax)
      nmy=NPIX(iay)
      vx=CELL(iax)
      vy=CELL(iay)
      theta=rad*CELL(mapk+3)

C*** CONVERTS 3D DATA INTO 2D DATA, DELC --> D ***
C
C    for mapk=1,2,3 (which means (100),(010),(001) sections)
C    axes of the 2-dim map are as follows: 
C       mapk  horizontal  vertikal
C        1       +b          +c
C        2       +c          +a
C        3       +a          +b
C                                
      DO 20 nh=0,nmx-1
      DO 20 nv=0,nmy-1
         dd=0.0
         DO 30 np=nin,nfn
            GO TO (40,50,60),mapk
   40       dd=dd+DELC(np,nh,nv)
            GO TO 30
   50       dd=dd+DELC(nv,np,nh)
            GO TO 30
   60       dd=dd+DELC(nh,nv,np)
   30    CONTINUE
         D(nh+1,nv+1)=dd
   20 CONTINUE
C
C*** calculate maximum and minimum values ***
C
      dmin=d(1,1)
      dmax=d(1,1)
      do 22 i=1,nmx
      do 22 j=1,nmy
	 dd=d(i,j)
         IF (dd.LT.dmin) dmin=dd
         IF (dd.GT.dmax) dmax=dd
22    continue

C*** EDITS 2D DATA ***
C
C     *** Shift the origin ?
      CALL SFTDAT(mpix,nmx,nmy,D,imapso,imapsx,imapsy)
C     *** Transpose axes (x-->y, y-->x) ?
      CALL TR2D(mapt,mpix,nmx,nmy,D,vx,vy,axisX,axisY,imaptr)
C     *** Doubling of the map (cell) ?
      CALL UCMUL(mpix,nmx,nmy,lx,ly,D,imapuc)
C     *** Add values for an edge
      CALL EDGED(mpix,lx,ly,D)
C
      RETURN
      END
C
