C--------------------------------------------------------------------
C     PRODUCE FILE CONTAINING a 2-dim MAP 
C     Files are produced in a format suitable for the program SURFER
C     for PC-computers
C--------------------------------------------------------------------
C
      SUBROUTINE MECORES(mpix,rad,theta,vx,vy,dmin,dmax,
     $  mapt,lx,ly,axisX,axisY,D)
C
      IMPLICIT INTEGER (I-N)
      implicit real*8 (a-h,o-z)
      dimension D(2*mpix+1,2*mpix+1)
      CHARACTER axisX*5,axisY*5
C       mapt = 1 | 2 | 3 | 4:  (110) | 100 | 010 | 001 plane
C       mapk =     1 | 2 | 3:          100 | 010 | 001 plane
C       D(1..lx,1..ly) = 2-dim map
C       lx,ly     = No. of pixels along x and y direction (with edge)
C    		    if a normal cell was chosen: lx=nmx+1 
C                   if a double cell was chosen, lx=2*nmx+1
C       theta     = angle between chosen axes
C       vx,vy     = cell constants along chosen axes
C       dmax,dmin = maximum and minimum of density in map

      integer iok,iwas

      write(*,*)
789   format('   The angle between the two axes is ',f6.2,' degrees')
791   format('   X-axis: ',A5,'    Y-axis:',A5)
      write(*,789) theta/rad
      write(*,791) axisX,axisY
792   format('   Min=',f12.4,'  Max=',f12.4)
      write(*,792)  dmin, dmax 
      print *

      iskal=0
111   write(*,1112) 
1112  format(' Do you like the map-axes to be scaled with',
     $  ' cell-constants (0=yes) ?',$)
      read(*,'(BN,I3)',ERR=111) iskal

C
      if (abs(theta/RAD-90.0) .lt. 0.1) then
	 print *, 'The map axes are perpendicular, you can get'
     $      ,' a GRID-file'
	 iwas=0
         iok=0
1122     format(' Is this ok ? (yes=0/ no=1) ',$)
112      write(*,1122)
         read(*,'(BN,I3)',ERR=112) iok
         if (iok.ne.0) iwas=1
      else
	 iwas=1
      endif
C
      if  (iwas.ne.0) then
         CALL SURFASC(axisX,axisY,theta,rad,iskal,vx,vy
     $      ,mpix,lx,ly,D)
      else
         CALL SURFGRID(iskal,vx,vy,mpix,lx,ly,D,dmin,dmax)
      endif

      return
      end
