C pap_space.f
C holt Symmetrieoperatoren aus der Raumgruppendatei zum Programm
C SMEED.f von SAKATA (MAXIMUM-ENTROPY-Programm)
C --> ergibt Datei SYMMETRY.SSG in Format fuer Papoular-Programm
C Datei: SPGRA.DATA
C
C (K. Burger, Januar 1995)
C
C====================================================================
C
C     - SMEEDT.FORT ( TSS VERSION ) -
C
C     MAXIMUM ENTROPY ELECTRON DENSITY ANALYSIS PROGRAM
C     FOR X-RAY POWDER DIFFRACTION DATA
C     REFERENCE : J.APPL.CRYST. (1990) 23, 526-534
C     COPYRIGHT BY SHINTARO KUMAZAWA ( NAGOYA UNIVERCITY )
C     ALL RIGHT RESERVED.
C
C     - UPDATE LABEL -
C     VERSION 3.00  1991-11-15  BY SHINTARO KUMAZAWA
C      MODIFIED BY USING OF MAU METHOD.
C
C     - CAUTION !! -
C
C     (1) IF YOU TRY A SAMPLE HAVING NO CENTRE OF SYMMETRY, YOU MUST
C         REMOVE THE COMMENT MARK, 'CENT'.
C     (2) YOU ARE NOT AVAILABLE FOR OLD FORMAT MEM DATA SET.
C     (3) SUBROUTINES DATE & WATCH CAN BE ONLY USED BY FACOM COMPUTER.
C     (4) PARAMETERS HAVE TO BE CHANGED IN THE SUBROUTINES, TOO.
C                i.e. MASYM  and  MPIX
C
C     - UNIT NUMBER OF DATA FILES -
C     40 : SPACE GROUP DATA BASE 'SPGRA', OFFERED BY FUJIO IZUMI.
C
C====================================================================
C
C
C*** MAIN ROUTINE ***    (Programmkopf uebernommen aus smeed.f)
C
      PROGRAM pap
C
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER ( MREF=50,MASYM=10000,MPIX=32)
      PARAMETER ( MHIST=10 )
      COMMON /COORD/NPIX(3),IASYM(3,MASYM),NASYM
      COMMON /CONST/CELL(6),TOTALE,RAMDA,RH,RK,RL,AS,BS,CS,GA,GB,GG,
     $              RDINT,FF1,FF2,POP,RTASYM,PI
      COMMON /SYMOP/IROT(3,3,48),ISUB(3,4),NSYM,NCEN,NSUB
      COMMON /SYMOP2/TRS(3,48)
      CHARACTER TITLE*70,FILMEM*30,FILDEN*30,FILDOC*30,
     $          ASPG*10,APRIOR*10,AGSW*5, cdummi*5
      DIMENSION APRIOR(2),AGSW(2),ITODAY(4),SUB(3,4)
      DATA (APRIOR(J),J=1,2)/'FLAT.     ','FILE DATA. '/
      DATA (AGSW(J),J=1,2)/'F & G','  F  '/
C
 1000 FORMAT(A70)
 1010 FORMAT(6F10.5)
 1015 FORMAT(F15.7,4I5)
 1020 FORMAT(6I5)
 1030 FORMAT(2F15.7)
 1040 FORMAT(I5)
 1050 FORMAT(3I5,3F15.7)
 1060 FORMAT(3I5,2F15.7,I5)
 1065 FORMAT(3I5,30X,I5)
 1070 FORMAT(3I5)
 1080 FORMAT()
 1090 FORMAT(2(3I5,F20.13))
 1100 FORMAT(12I5)
 2010 FORMAT(BN,A30)
 2020 FORMAT(BN,I5)
 3090 FORMAT(' ',3I3,1X,6F11.4)
 3110 FORMAT(' ',3I3,1X,F11.4,11X,F11.4,11X,2F11.4)
 3115 FORMAT(' ',3I3,45X,2F11.4)
 3000 FORMAT(4(/' '))
 4000 FORMAT(12F6.3)
 4010 FORMAT('  Raumgruppe Nr.',I3, ' Aufstellung ',I1,
     $ ' Name ', a10) 
C
C ************************************************************
C
  200 WRITE(*,*) ' Extrahieren der Raumgruppen-Symmetrieoperatoren'
      WRITE(*,*) ' aus der SAKATA-Raumgruppendatei '
      WRITE(*,*)
      WRITE(*,*) ' Gebe Nummer der Raumgruppe '
      READ(*,'(i3)') NSG
      WRITE(*,*) ' Gebe Nummer der Aufstellung '
      READ(*,'(i3)') NSET
      if (NSET.eq.0) NSET=1      

      WRITE(*,*) ' Ok ? (RETURN) '
      READ(5,2020) NYES
      IF (NYES.NE.0) GO TO 200
C
      NPIX(1)=30
      NPIX(2)=30
      NPIX(3)=30
   
C     *** NSG= Nr. der Raumgruppe, NSET=Aufstellung, ASPG=Name
C     *** NSUB=Anzahl der Zentrierungs-Translationen
C     ***      NSUB=2--> A,B,C,I, 3-->Rhomboedrisch, 4-->Innenzent.
C     *** ISUB(ii,i)=zugehoeriger Transl.-Vektor i
C
      CALL RDSPG(NSG,NSET,ASPG)
C
C     *** Nun noch Sub-Translationen dazu ***
      do 180 i=1,NSUB
      do 180 ii=1,3
C       *** ISUB() ist in Pixeln ganzzahlig angegeben ***
C       *** umrechnen auf relative x,y,z Koordinaten  ***
        SUB(ii,i)=float(ISUB(ii,i))/NPIX(ii)
180   continue
	 
      write(*,4010) NSG,NSET,ASPG
      print *
      print *,'Die vollstaendige Liste der Operatoren, entsprechend der'
      print *,'Symmetrie der allgemeinen Lage, wird erzeugt ...'
      print *,'Weiter mit RETURN'
      read(*,'(a)') cdummi
      WRITE(*,*) ' Einlesen beendet. Ausgabe in Datei',
     $     ' SYMMETRY.SSG ...'
      OPEN(10,FILE='SYMMETRY.SSG',FORM='FORMATTED',
     $     STATUS='UNKNOWN')
C     *** NSYM= Anzahl Symmetrieoperationen ohne Sub-Translationen
C     ***       von zentrierten Zellen (A,B,C,F,I,R) ***
      WRITE(10,'(I3)') NSYM*NSUB
      DO 190 K=1,NSYM
      DO 190 kk=1,NSUB
C     *** mod macht Verschiebung modulo 1 ( --> innerhalb Zelle) ***
      WRITE(*,4000) ((FLOAT(IROT(i,j,k)), j=1,3),
     $   float(mod(nint(60*(TRS(i,k)+SUB(i,kk))),60))/60, i=1,3) 
      WRITE(10,4000) ((FLOAT(IROT(i,j,k)), j=1,3),
     $   float(mod(nint(60*(TRS(i,k)+SUB(i,kk))),60))/60, i=1,3) 
190   CONTINUE 
      CLOSE(10)
      CLOSE(40)
      WRITE(*,*) 'Ausgabe in Datei SYMMETRY.SSG'
      WRITE(*,*) ' Fertig.'
      END
C ************************************************************
C
C
C--------------------------------------------------------------------
C     READ SPACE GROUP DATA BASE AND MAKE SYMMETRY OPERATIONS.
C--------------------------------------------------------------------
C
      SUBROUTINE RDSPG(NSG,NSET,ASPG)
C
      PARAMETER ( MASYM=10000 )
      REAL*8 TRS
      COMMON /COORD/NPIX(3),IASYM(3,MASYM),NASYM
      COMMON /SYMOP/IROT(3,3,48),ISUB(3,4),NSYM,NCEN,NSUB
      COMMON /SYMOP2/TRS(3,48)
      CHARACTER ASPG*10,COORD*20,CH*1,XYZ*1,SYM*10,CD*20
      DIMENSION COORD(48),XYZ(3),SYM(3),IX(3),burg(3)
      DATA (XYZ(J),J=1,3)/'X','Y','Z'/
C
 1000 FORMAT(5I3,3X,A10)
 1010 FORMAT(14I2)
 1020 FORMAT(A20)
 1030 FORMAT()
C
C*** READ DATA BASE ***
C
C*** CAUTION : YOU MUST REPLACE SUBJECT-NAME INTO YOURS. ***
      OPEN(40,FILE='SPGRA.DAT',FORM='FORMATTED',STATUS='OLD',
     $     ACCESS='SEQUENTIAL')
C     *** ISG = Nr. der Space Group, ISET= Austellung (1 oder 2)
C     *** IDMY = Dummy
C     *** NCEN = 0 / 1 wenn kein / ein Inversionszentrum da ***
C     *** NSYM =  Anzahl Sym-Operatoren ***
C     *** ASPG = Name der R.G. ***
C     *** NN = Nummer der Zentrierung (P,A,B,C,F,I,R) ***
   10 READ(40,1000,END=20) ISG,ISET,IDMY,NCEN,NSYM,ASPG
      IF (NSG.EQ.ISG.AND.NSET.EQ.ISET) THEN
         READ(40,1010) (IDMY,I=1,6),NN,(IDMY,I=8,14)
         READ(40,1020) (COORD(I),I=1,NSYM)
         GO TO 25
      ELSE
         DO 15 IDMY=1,NSYM+1
            READ(40,1030)
   15    CONTINUE
      END IF
      GO TO 10
   20 WRITE(*,*) 'CAN NOT FIND YOUR SPACE GROUP SELECTION.'
      CLOSE(10)
      CLOSE(40)
      STOP
C
C*** CONVERT STRING INTO ROT MATRIX AND TRS VECTOR. ***
C
C*** Lese die Lage des Inversionszentrums ein ***
   25 if (NCEN.eq.1) then 
         nyes = 0
	 write(*,*) 'Inversionszentrum im Ursprung (ja=0) ?' 
         read(*,'(i1)') nyes 
   26    if (nyes.ne.0) then
           write(*,*) 'Gib Lage des I-Zentrums (x,y,z):'
           read(*,*) burg(1),burg(2),burg(3)
           if ((burg(1).gt.1.0).or.(burg(2).gt.1.0).or.
     $         (burg(3).gt.1.0)) goto 26
         endif
         write(*,*) 'I-zentrum Lage=',burg(1),burg(2),burg(3)
      endif
C
      DO 100 K=1,NSYM
         CD=COORD(K)
         I1=INDEX(CD,',')
         DO 40 J=I1+2,19
            READ(CD(J:J),'(A1)') CH
            IF (CH.EQ.',') THEN
               I2=J
               GO TO 50
            END IF
   40    CONTINUE
   50    SYM(1)=CD(1:I1-1)
         SYM(2)=CD(I1+1:I2-1)
         SYM(3)=CD(I2+1:20)
         DO 80 I=1,3
            TRS(I,K)=0.0
            DO 60 J=1,3
               IROT(I,J,K)=0
   60       CONTINUE
            DO 70 J=1,3
               IX(J)=INDEX(SYM(I),XYZ(J))
               IF (IX(J).GT.0) THEN
                  IF (IX(J).EQ.1) THEN
                     IROT(I,J,K)=1
                  ELSE
                     IF (SYM(I)(IX(J)-1:IX(J)-1).EQ.'+') THEN
                        IROT(I,J,K)=1
                     ELSE
                        IROT(I,J,K)=-1
                     END IF
                  END IF
               END IF
   70       CONTINUE
C  *** Verschiebung suchen, dann ist ein +1/2 o.ae. in Angabe
            IT=INDEX(SYM(I),'/')
            IF (IT.GT.0) THEN
               READ(SYM(I)(IT-1:IT-1),'(I1)') ITR1
               READ(SYM(I)(IT+1:IT+1),'(I1)') ITR2
               IF (IT.NE.2.AND.SYM(I)(IT-2:IT-2).EQ.'-') ITR1=-ITR1
               IF (ITR2.NE.0) TRS(I,K)=1.0*ITR1/ITR2
            END IF
   80    CONTINUE
  100 CONTINUE
      DO 199 K=1,NSYM
 4000   FORMAT(12F6.3)
        WRITE(*,4000) ((FLOAT(IROT(i,j,k)), j=1,3),TRS(i,k),i=1,3) 
        WRITE(10,4000) ((FLOAT(IROT(i,j,k)), j=1,3),TRS(i,k),i=1,3) 
199   CONTINUE 
      if (NCEN.eq.1) then
C     *** jetzt noch Inversion am Zentrum ***
C         beachte Lage des Zentrums, falls nicht auf Ursprung
	  do 105 k=1,nsym
          do 105 ibu1=1,3 
           TRbur=2*burg(ibu1)-TRS(ibu1,K)
           if (TRbur.ge.1.0) TRbur= TRbur-1.0
           if (TRbur.ge.1.0) TRbur= TRbur-1.0
           if (TRbur.lt.0.0) TRbur= TRbur+1.0
           if (TRbur.lt.0.0) TRbur= TRbur+1.0
           TRS(ibu1,K+NSYM)=TRbur
           do 105 ibu2=1,3 
             IROT(ibu1,ibu2,K+NSYM)=-IROT(ibu1,ibu2,K)
  105      continue
	NSYM=NSYM*2
      endif
C
C*** MAKE SUB-LATTICE TRS VECTORS. ***
C
      NSUB=1
      IF (NN.EQ.7) THEN
C*** F LATTICE ***
         ISUB(2,2)=NPIX(2)/2
         ISUB(3,2)=NPIX(3)/2
         ISUB(1,3)=NPIX(1)/2
         ISUB(3,3)=NPIX(3)/2
         ISUB(1,4)=NPIX(1)/2
         ISUB(2,4)=NPIX(2)/2
         NSUB=4
      ELSE IF (NN.EQ.4) THEN
C*** A LATTICE ***
         ISUB(2,2)=NPIX(2)/2
         ISUB(3,2)=NPIX(3)/2
         NSUB=2
      ELSE IF (NN.EQ.5) THEN
C*** B LATTICE ***
         ISUB(1,2)=NPIX(1)/2
         ISUB(3,2)=NPIX(3)/2
         NSUB=2
      ELSE IF (NN.EQ.6) THEN
C*** C LATTICE ***
         ISUB(2,2)=NPIX(2)/2
         ISUB(1,2)=NPIX(1)/2
         NSUB=2
      ELSE IF (NN.EQ.13) THEN
C*** I LATTICE ***
         ISUB(1,2)=NPIX(1)/2
         ISUB(2,2)=NPIX(2)/2
         ISUB(3,2)=NPIX(3)/2
         NSUB=2
      ELSE IF (NN.EQ.14) THEN
C*** RHOMBO HEDRALLY CENTERED ( OBVERESE SETTING ) ***
         ISUB(1,2)=2*NPIX(1)/3
         ISUB(2,2)=NPIX(2)/3
         ISUB(3,2)=NPIX(3)/3
         ISUB(1,3)=NPIX(1)/3
         ISUB(2,3)=2*NPIX(2)/3
         ISUB(3,3)=2*NPIX(3)/3
         NSUB=3
      ELSE IF (NN.EQ.15) THEN
C*** RHOMBO HEDRALLY CENTERED ( REVERESE SETTING ) ***
         ISUB(1,2)=NPIX(1)/3
         ISUB(2,2)=2*NPIX(2)/3
         ISUB(3,2)=NPIX(3)/3
         ISUB(1,3)=2*NPIX(1)/3
         ISUB(2,3)=NPIX(2)/3
         ISUB(3,3)=2*NPIX(3)/3
         NSUB=3
      END IF
C
      RETURN
      END
