C*** READ MEED DATA AND MAKE SOME CONSTANTS. ***
C
C* - The list of F-constraints: h k l A B sigma(|F|) (phased reflections)
C* - The list of G-constraints: hkl-list + 1 Gobs and s(Gobs) (groups of refl.)
C*   IDX(1..3,1..nref) contains the hkl-indices of ALL reflections
C*   FOBS(1..2,1..nrefF) contains the A and B of F-constraints
C*   GOBS(mref) contains the mean |F| of G-constraints: GOBS(1..nrefG)
C*     NGRP(1..nrefG) contains the number of reflections in group j
C*     SIGG(1..nrefG) contains the sigma of Gobs of group j
C*     PMUL(1..nrefG+..) contains the multiplicity of reflections in groups
C*     PMULS(1..nrefG) contains the sum of the multiplicities of group j
C*   nrefF,nrefG contain the numbers of constraints: F, G
C*   nref=total number of reflections
C
      SUBROUTINE READMEM(filmem,title,CELL,pop,iptyp,jph,jpk,jpl,
     $  nsg,nset,NPIX,mpix,totale,lambda,mref,nref,nrefF,nrefG,
     $  IDX,FOBS,SIGF,GOBS,SIGG,NGRP,PMUL,PMULS,ierr,igsw)
C
      IMPLICIT none
      integer iptyp,jph,jpk,jpl,nsg,nset,mpix,mref,nref,nrefF,nrefG,
     $     ierr,igsw,i,iref,igrp,mul
      real*8 CELL(6),FOBS(2,mref),SIGF(mref),GOBS(mref),
     $     SIGG(mref),PMUL(mref),PMULS(mref),lambda,pop,totale
      integer NPIX(3),IDX(3,mref),NGRP(mref)
      character filmem*50, title*200
 1000 FORMAT(A)
C  1015 FORMAT(F15.7,4I5)
C
      OPEN(10,FILE=FILMEM,FORM='FORMATTED',STATUS='OLD',
     $     ACCESS='SEQUENTIAL',ERR=201)
      ierr=0
      goto 202
C     *** error ***
201     print *,'file not found:',filmem
        ierr=1
        CLOSE(10)
        return
C
202   READ(10,1000) title
      READ(10,*) (CELL(I),I=1,6)
      READ(10,*) pop,iptyp,jph,jpk,jpl
      READ(10,*) nsg,nset,(NPIX(I),I=1,3)
      IF (NPIX(1)-1.GT.mpix.OR.NPIX(2)-1.GT.mpix.OR.
     $   NPIX(3)-1.GT.mpix) 
     $   CALL PROEND('DIMENSION OVER FOR IDE - TOO MANY PIXELS.')
      READ(10,*) totale,lambda
      READ(10,*) nrefF
      IF (nrefF.GT.mref)  then
	 print *,'Maximal number of reflections:',mref
	 print *,'Given number                 :',nrefF
	 CALL PROEND('Too many Fobs given.')
      ENDIF
      DO 10 nref=1,nrefF
C        READ(10,1050)  (in earlier version: formatted input)
         READ(10,*)
     $   (IDX(I,nref),I=1,3),(FOBS(I,nref),I=1,2),SIGF(nref)
         SIGF(nref)=SIGF(nref)**2
   10 CONTINUE
      nref=nref-1
      write(*,*) nref, ' reflections Fobs found'
      if (igsw.eq.1) then
         nrefG=0
         GOTO 30
      endif
C     READ(10,1040,END=30) nrefG
      nrefG=0
      READ(10,*,END=30) nrefG
      IF (nrefG.eq.0) then
	 write(*,*) 'No Gobs found!'
	 igsw=1
	 GO TO 30
      elseif (nrefG.gt.mref) then
	 print *,'Maximal number of groups of reflections:',mref
	 print *,'Given number                           :',nrefG
	 CALL PROEND('Too many Gobs given.')
      ENDIF
      write(*,*) nrefG, ' groups of reflections Gobs'
      DO 20 iref=1,nrefG
C        READ(10,1040) NGRP(iref)
         READ(10,*) NGRP(iref)
         PMULS(iref)=0.0
         DO 25 igrp=1,NGRP(iref)
            nref=nref+1
            IF (nref.gt.mref) CALL PROEND(
     $        'DIMENSION OVER FOR FCAL - TOO MANY REFLECTIONS')
            IF (igrp.EQ.1) THEN
C              READ(10,1060)
               READ(10,*)
     $         (IDX(i,nref),i=1,3),GOBS(iref),SIGG(iref),mul
                 SIGG(iref)=SIGG(iref)**2
            ELSE
C              READ(10,1065) (IDX(i,nref),i=1,3),mul
               READ(10,*) (IDX(i,nref),i=1,3),mul
            END IF
	    if (mul.eq.0) then
              print *,(IDX(i,nref),i=1,3),mul
              call proend(
     $         'Error in input: Multiplicity of Gobs is zero')
            endif
            PMUL(nref-nrefF)=DFLOAT(mul)
            PMULS(iref)=PMULS(iref)+DFLOAT(mul)
   25    CONTINUE
   20 CONTINUE
   30 CLOSE(10)
      if (nrefG.eq.0) igsw=1
C
      return
      end
