C     create ASCII file for the Program SURFER for PC (WINDOWS-Version) 
C
      SUBROUTINE SURFASC(axisX,axisY,theta,rad,iskal,vx,vy,
     $   mpix,lx,ly,D)

      implicit integer (i-n)
      implicit real*8 (a-h,o-z)
      dimension D(2*mpix+1,2*mpix+1)
      character name*50,axisX*5,axisY*5 

C     ------------ ASCII Datei erzeugen -----------------------------

800   name='bild.txt'
      write(*,8001) name(1:8)
8001  format(' Name of ASCII file for SURFER ? (', a, ') ',$)
      read(*,'(A50)') name
      if (name(1:9).eq.'         ') name='bild.txt'
      write(*,*) 'Output to file ',name
      open(7,file=name,status='unknown',err=800)
      write(7,*) '     ',axisX,'     ',axisY, '        density'

C     *** If the axes are not perpendicular (theta/rad not 90 degrees)
C     *** the remaining triangles at the edges are filled using the
C     *** periodicity of the map.
C     *** In the SURFER program, interpolating to an rectangular grid
C     *** is made automatically afterwords.
C
C     *** rx, ry are in pixel units, but calculated for rectangular axes
      rcos=cos(theta)
      rsin=sin(theta)
      if (iskal.eq.0) then
C       * with scaling with cell-constants vx, vy 
        vvx=vx/(lx-1)
        vvy=vy/(ly-1)
      else
C       * without scaling, use relative coordinates x=0...1, y=0...rsin 
        vvx=1./(lx-1)
        vvy=1./(ly-1)
      endif
C     *** write main part of map ***
      do 200 iy=1,ly
      do 200 ix=1,lx
        rx = ix-1 + (iy-1)*rcos
        ry = (iy-1)*rsin
C       write(7,99) rx*vvx, ry*vvy, D(ix,iy)
        write(7,*) sngl(rx*vvx), sngl(ry*vvy), sngl(D(ix,iy))
200   continue
C 99   format (f16.6,1x,f16.6,1x,f16.6)

C     *** calculate corners and minimum/maximum of coordinates
      rx=lx-1+(ly-1)*rcos
      ry=(ly-1)*rsin
      rrx=abs(rx-(lx-1))
      if (theta/RAD.gt. 90) then
        xmin=(ly-1)*rcos
        xmax=lx-1.
      else
        xmin=0
        xmax=lx-1+(ly-1)*rcos
      endif

C     *** fill edge ***
      if (abs(theta/RAD-90).gt.0.2) then

        do 110 i=1,int(rrx)
        do 110 j=1,ly
          x=lx-1+i+(j-1)*rcos
          y=(j-1)*rsin
          dd=D(i+1,j)
          if (x.gt.xmax) then
            x=x-(xmax-xmin)
            dd=D(lx-int(rrx)+i,j)
          endif
          write(7,*) sngl(x*vvx), sngl(y*vvy), sngl(dd)
110     continue

C       *** last corner ***
        if (theta/RAD.gt.90.) then
          write(7,*) 0,0, sngl(D(lx-int(rrx),1))
        else
          write(7,*) 0,sngl(ry*vvy), sngl(D(lx-int(rrx),ly))
        endif

      endif     

      close(7)
      return

      end
